ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/cvsroot/App-Staticperl/staticperl.sh
Revision: 1.38
Committed: Fri Apr 1 05:58:22 2011 UTC (13 years, 3 months ago) by root
Content type: application/x-sh
Branch: MAIN
Changes since 1.37: +6 -1 lines
Log Message:
*** empty log message ***

File Contents

# Content
1 #!/bin/sh
2
3 #############################################################################
4 # configuration to fill in
5
6 STATICPERL=~/.staticperl
7 CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8 EMAIL="read the documentation <rtfm@example.org>"
9
10 # perl build variables
11 MAKE=make
12 PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13 PERL_CC=cc
14 PERL_CONFIGURE="" # additional Configure arguments
15 PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16 PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17
18 ARCH="$(uname -m)"
19
20 case "$ARCH" in
21 i*86 | x86_64 | amd64 )
22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
23 case "$ARCH" in
24 i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;;
27 esac
28 ;;
29 esac
30
31 # -Wl,--gc-sections makes it impossible to check for undefined references
32 # for some reason so we need to patch away the "-no" after Configure and before make :/
33 # --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34 #PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35 PERL_LDFLAGS=
36 PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37
38 # some configuration options for modules
39 PERL_MM_USE_DEFAULT=1
40 #CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41 EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
42 export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
43
44 # which extra modules to install by default from CPAN that are
45 # required by mkbundle
46 STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
47
48 # which extra modules you might want to install
49 EXTRA_MODULES=""
50
51 # overridable functions
52 preconfigure() { : ; }
53 patchconfig() { : ; }
54 postconfigure() { : ; }
55 postbuild() { : ; }
56 postinstall() { : ; }
57
58 # now source user config, if any
59 if [ "$STATICPERLRC" ]; then
60 . "$STATICPERLRC"
61 else
62 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
63 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
64 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
65 fi
66
67 #############################################################################
68 # support
69
70 MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
71 PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
72
73 unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74 unset PERL_MM_OPT PERL_MB_OPT
75 LC_ALL=C; export LC_ALL # just to be on the safe side
76
77 # prepend PATH - not required by staticperl itself, but might make
78 # life easier when working in e.g. "staticperl cpan / look"
79 PATH="$PERL_PREFIX/perl/bin:$PATH"
80
81 # set version in a way that Makefile.PL can extract
82 VERSION=VERSION; eval \
83 $VERSION="1.21"
84
85 BZ2=bz2
86 BZIP2=bzip2
87
88 fatal() {
89 printf -- "\nFATAL: %s\n\n" "$*" >&2
90 exit 1
91 }
92
93 verbose() {
94 printf -- "%s\n" "$*"
95 }
96
97 verblock() {
98 verbose
99 verbose "***"
100 while read line; do
101 verbose "*** $line"
102 done
103 verbose "***"
104 verbose
105 }
106
107 rcd() {
108 cd "$1" || fatal "$1: cannot enter"
109 }
110
111 trace() {
112 prefix="$1"; shift
113 # "$@" 2>&1 | while read line; do
114 # echo "$prefix: $line"
115 # done
116 "$@"
117 }
118
119 trap wait 0
120
121 #############################################################################
122 # clean
123
124 distclean() {
125 verblock <<EOF
126 deleting everything installed by this script (rm -rf $STATICPERL)
127 EOF
128
129 rm -rf "$STATICPERL"
130 }
131
132 #############################################################################
133 # download/configure/compile/install perl
134
135 clean() {
136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
137 }
138
139 realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
143 }
144
145 fetch() {
146 rcd "$STATICPERL"
147
148 mkdir -p src
149 rcd src
150
151 if ! [ -d "perl-$PERL_VERSION" ]; then
152 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
153
154 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
155
156 verblock <<EOF
157 downloading perl
158 to manually download perl yourself, place
159 perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
160 trying $URL
161 EOF
162
163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
166 || fatal "$URL: unable to download"
167 rm -f perl-$PERL_VERSION.tar.$BZ2
168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
169 fi
170
171 verblock <<EOF
172 unpacking perl
173 EOF
174
175 mkdir -p unpack
176 rm -rf unpack/perl-$PERL_VERSION
177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
179 chmod -R u+w unpack/perl-$PERL_VERSION
180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
181 rmdir -p unpack
182 fi
183 }
184
185 # similar to GNU-sed -i or perl -pi
186 sedreplace() {
187 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
188 rm -f "$2"
189 mv "$2~" "$2"
190 }
191
192 configure_failure() {
193 cat <<EOF
194
195
196 ***
197 *** Configure failed - see above for the exact error message(s).
198 ***
199 *** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
200 *** flags are not supported by your compiler. Less often, this is because
201 *** PERL_LIBS either contains a library not available on your system (such as
202 *** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
203 ***
204 *** You can provide your own flags by creating a ~/.staticperlrc file with
205 *** variable assignments. For example (these are the actual values used):
206 ***
207
208 PERL_CC="$PERL_CC"
209 PERL_CCFLAGS="$PERL_CCFLAGS"
210 PERL_OPTIMIZE="$PERL_OPTIMIZE"
211 PERL_LDFLAGS="$PERL_LDFLAGS"
212 PERL_LIBS="$PERL_LIBS"
213
214 EOF
215 exit 1
216 }
217
218 configure() {
219 fetch
220
221 rcd "$STATICPERL/src/perl-$PERL_VERSION"
222
223 [ -e staticstamp.configure ] && return
224
225 verblock <<EOF
226 configuring $STATICPERL/src/perl-$PERL_VERSION
227 EOF
228
229 rm -f "$PERL_PREFIX/staticstamp.install"
230
231 "$MAKE" distclean >/dev/null 2>&1
232
233 sedreplace '/^#define SITELIB/d' config_h.SH
234
235 # I hate them for this
236 grep -q -- -fstack-protector Configure && \
237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
238
239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
244
245 # trace configure \
246 sh Configure -Duselargefiles \
247 -Uuse64bitint \
248 -Dusemymalloc=n \
249 -Uusedl \
250 -Uusethreads \
251 -Uuseithreads \
252 -Uusemultiplicity \
253 -Uusesfio \
254 -Uuseshrplib \
255 -Uinstallusrbinperl \
256 -A ccflags=" $PERL_CCFLAGS" \
257 -Dcc="$PERL_CC" \
258 -Doptimize="$PERL_OPTIMIZE" \
259 -Dldflags="$PERL_LDFLAGS" \
260 -Dlibs="$PERL_LIBS" \
261 -Dprefix="$PERL_PREFIX" \
262 -Dbin="$PERL_PREFIX/bin" \
263 -Dprivlib="$PERL_PREFIX/lib" \
264 -Darchlib="$PERL_PREFIX/lib" \
265 -Uusevendorprefix \
266 -Dsitelib="$PERL_PREFIX/lib" \
267 -Dsitearch="$PERL_PREFIX/lib" \
268 -Uman1dir \
269 -Uman3dir \
270 -Usiteman1dir \
271 -Usiteman3dir \
272 -Dpager=/usr/bin/less \
273 -Demail="$EMAIL" \
274 -Dcf_email="$EMAIL" \
275 -Dcf_by="$EMAIL" \
276 $PERL_CONFIGURE \
277 -Duseperlio \
278 -dE || configure_failure
279
280 sedreplace '
281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
282 s/ *-fno-stack-protector */ /g
283 ' config.sh
284
285 patchconfig || fatal "patchconfig hook failed"
286
287 sh Configure -S || fatal "Configure -S failed"
288
289 postconfigure || fatal "postconfigure hook failed"
290
291 touch staticstamp.configure
292 }
293
294 build() {
295 configure
296
297 rcd "$STATICPERL/src/perl-$PERL_VERSION"
298
299 verblock <<EOF
300 building $STATICPERL/src/perl-$PERL_VERSION
301 EOF
302
303 rm -f "$PERL_PREFIX/staticstamp.install"
304
305 "$MAKE" || fatal "make: error while building perl"
306
307 postbuild || fatal "postbuild hook failed"
308 }
309
310 install() {
311 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
312 build
313
314 verblock <<EOF
315 installing $STATICPERL/src/perl-$PERL_VERSION
316 to $PERL_PREFIX
317 EOF
318
319 ln -sf "perl/bin/" "$STATICPERL/bin"
320 ln -sf "perl/lib/" "$STATICPERL/lib"
321
322 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
323 rm -rf "$PERL_PREFIX" # by this rm -rf
324
325 "$MAKE" install || fatal "make install: error while installing"
326
327 rcd "$PERL_PREFIX"
328
329 # create a "make install" replacement for CPAN
330 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
331 "$MAKE" || exit
332
333 # patch CPAN::HandleConfig.pm
334 HCPM="$PERL_PREFIX"/lib/CPAN/HandleConfig.pm
335 case "\$(head -n1 "\$HCPM")" in
336 *CPAN::MyConfig* )
337 ;;
338 * )
339 echo "patching \$HCPM for a safer tomorrow"
340 {
341 echo "use CPAN::MyConfig;"
342 cat "\$HCPM"
343 } >"\$HCPM~"
344 rm -f "\$HCPM"
345 mv "\$HCPM~" "\$HCPM"
346 ;;
347 esac
348
349 if find blib/arch/auto -type f | grep -q -v .exists; then
350 echo Probably an XS module, rebuilding perl
351 if "$MAKE" perl; then
352 mv perl "$PERL_PREFIX"/bin/perl~ \
353 && rm -f "$PERL_PREFIX"/bin/perl \
354 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
355 "$MAKE" -f Makefile.aperl map_clean
356 else
357 "$MAKE" -f Makefile.aperl map_clean
358 exit 1
359 fi
360 fi
361
362 "$MAKE" install UNINST=1
363 EOF
364 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
365
366 # trick CPAN into avoiding ~/.cpan completely
367 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
368
369 # we call cpan with -MCPAN::MyConfig in this script, but
370 # every make install will patch CPAN::HandleConfig.pm to
371 # protect the user.
372
373 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
374 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
375 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
376 CPAN::Shell->o (conf => q<init>);
377 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
378 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
379 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
380 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
381 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
382 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
383 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
384 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
385 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
386 CPAN::Shell->o (conf => q<commit>);
387 ' || fatal "error while initialising CPAN"
388
389 touch "$PERL_PREFIX/staticstamp.install"
390 fi
391
392 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
393 NOCHECK_INSTALL=+
394 instcpan $STATICPERL_MODULES
395 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
396
397 postinstall || fatal "postinstall hook failed"
398
399 touch "$PERL_PREFIX/staticstamp.postinstall"
400 fi
401 }
402
403 #############################################################################
404 # install a module from CPAN
405
406 instcpan() {
407 [ $NOCHECK_INSTALL ] || install
408
409 verblock <<EOF
410 installing modules from CPAN
411 $@
412 EOF
413
414 for mod in "$@"; do
415 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
416 || fatal "$mod: unable to install from CPAN"
417 done
418 rm -rf "$STATICPERL/build"
419 }
420
421 #############################################################################
422 # install a module from unpacked sources
423
424 instsrc() {
425 [ $NOCHECK_INSTALL ] || install
426
427 verblock <<EOF
428 installing modules from source
429 $@
430 EOF
431
432 for mod in "$@"; do
433 echo
434 echo $mod
435 (
436 rcd $mod
437 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
438 "$MAKE" distclean >/dev/null 2>&1
439 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
440 "$MAKE" || fatal "$mod: error building module"
441 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
442 "$MAKE" distclean >/dev/null 2>&1
443 exit 0
444 ) || exit $?
445 done
446 }
447
448 #############################################################################
449 # main
450
451 podusage() {
452 echo
453
454 if [ -e "$PERL_PREFIX/bin/perl" ]; then
455 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
456 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
457 2>/dev/null && exit
458 fi
459
460 # try whatever perl we can find
461 perl -MPod::Usage -e \
462 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
463 2>/dev/null && exit
464
465 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
466 }
467
468 usage() {
469 podusage 0
470 }
471
472 catmkbundle() {
473 {
474 read dummy
475 echo "#!$PERL_PREFIX/bin/perl"
476 cat
477 } <<'MKBUNDLE'
478 #CAT mkbundle
479 MKBUNDLE
480 }
481
482 bundle() {
483 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
484 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
485 CACHE="$STATICPERL/cache"
486 mkdir -p "$CACHE"
487 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
488 }
489
490 if [ $# -gt 0 ]; then
491 while [ $# -gt 0 ]; do
492 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
493 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
494
495 command="${1#--}"; shift
496 case "$command" in
497 version )
498 echo "staticperl version $VERSION"
499 ;;
500 fetch | configure | build | install | clean | realclean | distclean)
501 ( "$command" ) || exit
502 ;;
503 instsrc )
504 ( instsrc "$@" ) || exit
505 exit
506 ;;
507 instcpan )
508 ( instcpan "$@" ) || exit
509 exit
510 ;;
511 cpan )
512 ( install ) || exit
513 "$PERL_PREFIX/bin/cpan" "$@"
514 exit
515 ;;
516 mkbundle )
517 ( install ) || exit
518 bundle "$@"
519 exit
520 ;;
521 mkperl )
522 ( install ) || exit
523 bundle --perl "$@"
524 exit
525 ;;
526 mkapp )
527 ( install ) || exit
528 bundle --app "$@"
529 exit
530 ;;
531 help )
532 podusage 2
533 ;;
534 * )
535 exec 1>&2
536 echo
537 echo "Unknown command: $command"
538 podusage 0
539 ;;
540 esac
541 done
542 else
543 usage
544 fi
545
546 exit 0
547
548 #CAT staticperl.pod
549